package com.sap.cloud.sample.helloworld.test;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import org.easymock.EasyMock;
import org.junit.Assert;
import org.junit.Test;

import com.sap.cloud.sample.helloworld.HelloWorldServlet;

import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

/**
 * Unit test for hello world servlet using EasyMock and ServletUnit.
 */
public class HelloWorldServletTest {
    /**
     * Example for a test using EasyMock on a SAP BTP application.
     */
    @Test
    public void testHelloWorldUsingEasyMock() throws IOException, ServletException {
        // Create required mock objects
        HttpServletRequest mockRequest = EasyMock.createMock(HttpServletRequest.class);
        HttpServletResponse mockResponse = EasyMock.createMock(HttpServletResponse.class);
        StringWriter mockWriter = new StringWriter();
        EasyMock.expect(mockResponse.getWriter()).andReturn(new PrintWriter(mockWriter));
        EasyMock.replay(mockRequest, mockResponse);

        // Call servlet
        new HelloWorldServlet().doGet(mockRequest, mockResponse);

        // Check for string "Hello" in the returned response
        EasyMock.verify(mockRequest, mockResponse);
        Assert.assertTrue(mockWriter.getBuffer().indexOf("Hello World") != -1);
    }

}
